type 'a t = Empty | Node of ('a t * 'a * 'a t)

val flatten : 'a t -> 'a list
val height : 'a t -> int
val insert : ('a -> 'a -> int) -> 'a -> 'a t -> 'a t
val make : 'a list -> 'a t
val of_list : 'a list -> 'a t
val search_tree : ('a -> 'a -> int) -> 'a list -> 'a t
val size : 'a t -> int
